<?php

foreach(file('GeoLite2-Country-Locations-en.csv') as $line)
{
  list($id,,,,$code) = explode(',', $line);
  $codes[$id] = $code;
}

foreach(file('GeoLite2-Country-Blocks-IPv4.csv') as $line)
{
  list($block,$id) = explode(',', $line);
  if($id == 0) continue;
  list($start,$bits) = explode('/', $block);

  $mask = (0xffffffff << (32 - $bits)) & 0xffffffff;
  $start = ip2int32($start) & $mask;
  $end = ((~$mask) & 0xffffffff) | $start;
  $startt = long2ip($start);
  $endt = long2ip($end);
  echo "$startt,$endt,$start,$end,{$codes[$id]}\n";
}

function ip2int32($ip)
{
  $ip = ip2long($ip);
  if($ip === false) return false;
  list(,$ip) = unpack('l', pack('l', $ip));
  return $ip;
}

